/*****************************************************************
 
  keycodes.h
 
  Copyright (c) 2005 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de
 
  http://gmerlin.sourceforge.net
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
 
*****************************************************************/

/*
 *  System independent keycode definitions
 */

/** \defgroup keycodes System independent keycode definitions
 *  \ingroup plugin_ov
 *
 *  @{
 */

#define BG_KEY_SHIFT_MASK    (1<<0) //!< Shift
#define BG_KEY_CONTROL_MASK  (1<<1) //!< Control
#define BG_KEY_ALT_MASK      (1<<2) //!< Alt

#define BG_KEY_NONE      -1 //!< Undefined

#define BG_KEY_0          0 //!< 0
#define BG_KEY_1          1 //!< 1
#define BG_KEY_2          2 //!< 2
#define BG_KEY_3          3 //!< 3
#define BG_KEY_4          4 //!< 4
#define BG_KEY_5          5 //!< 5
#define BG_KEY_6          6 //!< 6
#define BG_KEY_7          7 //!< 7
#define BG_KEY_8          8 //!< 8
#define BG_KEY_9          9 //!< 9

#define BG_KEY_SPACE      10 //!< Space
#define BG_KEY_RETURN     11 //!< Return (Enter)
#define BG_KEY_LEFT       12 //!< Left
#define BG_KEY_RIGHT      13 //!< Right
#define BG_KEY_UP         14 //!< Up
#define BG_KEY_DOWN       15 //!< Down
#define BG_KEY_PAGE_UP    16 //!< Page Up
#define BG_KEY_PAGE_DOWN  17 //!< Page Down
#define BG_KEY_PLUS       18 //!< Plus
#define BG_KEY_MINUS      19 //!< Minus


#define BG_KEY_A 101 //!< a
#define BG_KEY_B 102 //!< b
#define BG_KEY_C 103 //!< c
#define BG_KEY_D 104 //!< d
#define BG_KEY_E 105 //!< e
#define BG_KEY_F 106 //!< f
#define BG_KEY_G 107 //!< g
#define BG_KEY_H 108 //!< h
#define BG_KEY_I 109 //!< i
#define BG_KEY_J 110 //!< j
#define BG_KEY_K 111 //!< k
#define BG_KEY_L 112 //!< l
#define BG_KEY_M 113 //!< m
#define BG_KEY_N 114 //!< n
#define BG_KEY_O 115 //!< o
#define BG_KEY_P 116 //!< p
#define BG_KEY_Q 117 //!< q
#define BG_KEY_R 118 //!< r
#define BG_KEY_S 119 //!< s
#define BG_KEY_T 120 //!< t
#define BG_KEY_U 121 //!< u
#define BG_KEY_V 122 //!< v
#define BG_KEY_W 123 //!< w
#define BG_KEY_X 124 //!< x
#define BG_KEY_Y 125 //!< y
#define BG_KEY_Z 126 //!< z

#define BG_KEY_F1 201 //!< F1
#define BG_KEY_F2 202 //!< F2
#define BG_KEY_F3 203 //!< F3
#define BG_KEY_F4 204 //!< F4
#define BG_KEY_F5 205 //!< F5
#define BG_KEY_F6 206 //!< F6
#define BG_KEY_F7 207 //!< F7
#define BG_KEY_F8 208 //!< F8
#define BG_KEY_F9 209 //!< F9
#define BG_KEY_F10 210 //!< F10
#define BG_KEY_F11 211 //!< F11
#define BG_KEY_F12 212 //!< F12

/**  @}
 */
